#!/usr/bin/gnuplot

set term post eps enh color solid
set out "chi2_SYN.eps"
set size 1.0,0.7

nm = 1.e-9  # m
shift = 0.25

set xl "{/Symbol l} [nm]"
set yl "{/Helvetica-Oblique I}_{/Symbol l} [] (shifted by dataset number)" offset 1,0

set xr [:460]
set yr [0:11.5]

set ytics 5
set mytics 5
set grid ytics mytics
set zeroaxis
set bar 0.1
set key samplen 1.0

load "config.plt"

p \
  "synthetic.dat" u ($2/nm):($3+shift*($4-1))   t "synthetic" w l lt 7,\
  "Spectra.dat"   u ($2/nm):($3+shift*($5-1)):4 t "observed" w err lt 3 pt 1 ps 0,\
  "chi2_SYN.dat"  u ($2/nm):($3+shift*($5-1))   t "residua"  w l lc 1 lw 1

q


